#
# $Id: Programme_Install.nsi 267 2010-11-19 19:56:02Z gingko $
# Copyright (C) 2007 lolo_32 <pouchintv-dev@baysse.fr>
#
# This file is part of Pouchin TV Mod, a free DVB-T viewer.
# See http://www.pouchintv.fr/ for updates.
#
# Pouchin TV Mod is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Pouchin TV Mod is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#
#
# Most files of this project have been changed from the Pouchin TV
# project (Copyright (C) 2006 Pouchin <pouchinteve@free.fr>),
# to use with a modified version of this software.
# See http://pouchinteve.free.fr/ for the original project.
#

; Script d'installation pour Pouchin TV Mod en 32 bits

;--------------------------------
;Style moderne

	!include "MUI.nsh"
	;Conditions pour le x64
	!include "x64.nsh"
	;Pour la gestion des sections
	!include "Sections.nsh"
	;Windows version utils
	!include "WinVer.nsh"

	;Rcupration du numro de version (gnr automatiquement au pralable)
	!include "..\version.nsh"
;--------------------------------
;Quelques constantes

;Construction du nom de l'application et du chemin d'accs, selon la configuration

	;Nom de la configuration  dfinir par /DEXE_SRC_DIR=xxxx en ligne de commande
	!ifndef EXE_SRC_DIR
		; Valeur par dfaut
		!define EXE_SRC_DIR "..\Builds\"
	!endif

	;$DEBUG_SFX est un suffixe ajout au nom de l'application et de l'installeur pour
	;diffrencier les versions Debug
	;Cette variable est  dfinir est  dfinir par /DDEBUG_SFX=xxxx en ligne de commande
	;Normalement vide (par dfaut) ou bien "_debug" ou "_diag"
	!ifndef DEBUG_SFX
		!define DEBUG_SFX ""
	!endif

	;$DSPDBG_SFX est un suffixe ajout au nom des rpertoires et des raccourcis du menu dmarrer
	;pour diffrencier les versions Debug
	;Cette variable est  dfinir est  dfinir par /DDSPDBG_SFX=xxxx en ligne de commande
	;Normalement vide (par dfaut) ou bien " (debug)" ou " (diag)"
	!ifndef DSPDBG_SFX
		!define DSPDBG_SFX ""
	!endif

	;$SBCS_SUFFIX est un suffixe ajout au nom de l'installeur pour diffrencier les versions SBCS
	;Cette variable est  dfinir par /DSBCS_SFX=xxxx en ligne de commande
	;Normalement vide (par dfaut) ou bien "_sbcs"
	!ifndef SBCS_SFX
		!define SBCS_SFX ""
	!endif

	;$APP_BASENAME est le nom de base de l'application
	;Cette variable *peut* se redfinir par /DAPP_BASENAME=xxxx en ligne de commande
	!ifndef APP_BASENAME
		!define APP_BASENAME MMzinTV
	!endif

	!define PRODUCT_BASE_NAME "MMzinTV"
	!define PRODUCT_NAME "${PRODUCT_BASE_NAME}${DSPDBG_SFX}"
	!define PRODUCT_COMMENT "http://www.mmzin.com, http://www.pouchintv.fr/, http://www.etud.insa-toulouse.fr/~mvelten/pouchintvmod/, http://pouchinteve.free.fr/"
	!define PRODUCT_INSTALL_DESCRIPTION "  ${PRODUCT_NAME}"
	!define PRODUCT_WEB_SITE "http://www.mmzin.com"
	!define PRODUCT_UNINST_KEY "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
	!define PRODUCT_UNINST_ROOT_KEY HKLM

	!define EXE_SRC_DIR_X86 "${EXE_SRC_DIR}"
	!define EXE_SRC_DIR_X64 "${EXE_SRC_DIR}x64\"
	!define EXE_BASENAME_X86 "${APP_BASENAME}${DEBUG_SFX}"
	!define EXE_BASENAME_X64 "${EXE_BASENAME_X86}_x64"
	!define INSTALL_FILENAME "${EXE_BASENAME_X86}${SBCS_SFX}_setup.${PRODUCT_VERSION}.exe"

;--------------------------------
;Gnral

	;Nom et fichier
	Name "${PRODUCT_NAME}"
	OutFile "${EXE_SRC_DIR}${INSTALL_FILENAME}"

	;Rpertoire par dfaut vide
	InstallDir ""

	;Rcupre le dossier d'installation d'une prcdente installation
	InstallDirRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "InstallLocation"

	;Compresse en utilisant LZMA
	SetCompressor /SOLID lzma

	;Sauvegarde le CRC du fichier (pour download non corrompu)
	CRCCheck on

	;Demande les droits admin pour Vista
	RequestExecutionLevel admin

	;Active les boutons avec le style Windows XP
	XPStyle on

	;Rcupre le chemin vers la page pour le menu dmarrer
	!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
	!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
	!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "Start Menu"

;--------------------------------
;Variables

	Var STARTMENU_FOLDER
	Var INSTALL_X64
	Var DRIVERS_CHECK

;--------------------------------
;Interface

	!define MUI_ICON "install.ico"
	!define MUI_UNICON "uninstall.ico"
	!define MUI_WELCOMEFINISHPAGE_BITMAP "welcome-install.bmp"
	!define MUI_UNWELCOMEFINISHPAGE_BITMAP "welcome-uninstall.bmp"
	!define MUI_COMPONENTSPAGE_CHECKBITMAP "checks.bmp"
	!define MUI_COMPONENTSPAGE_NODESC
	!define MUI_FINISHPAGE_NOAUTOCLOSE

	!define MUI_HEADERIMAGE
	!define MUI_HEADERIMAGE_BITMAP "header-install.bmp"
	!define MUI_HEADERIMAGE_UNBITMAP "header-uninstall.bmp"
	!define MUI_ABORTWARNING

;--------------------------------
;Pages

	!insertmacro MUI_PAGE_WELCOME
	!insertmacro MUI_PAGE_LICENSE "gpl.txt"
	LicenseForceSelection checkbox ;Necessit de cocher la case Accepter la license
	!insertmacro MUI_PAGE_COMPONENTS
	!define MUI_PAGE_CUSTOMFUNCTION_PRE ChangeRep
	!insertmacro MUI_PAGE_DIRECTORY
	!insertmacro MUI_PAGE_STARTMENU Application $STARTMENU_FOLDER
	!insertmacro MUI_PAGE_INSTFILES
	!insertmacro MUI_PAGE_FINISH

	!insertmacro MUI_UNPAGE_WELCOME
	!insertmacro MUI_UNPAGE_CONFIRM
	!insertmacro MUI_UNPAGE_INSTFILES
	!insertmacro MUI_UNPAGE_FINISH

;--------------------------------
;Langues

	!insertmacro MUI_LANGUAGE "Bulgarian"

;--------------------------------
;Informations de versions sur l'installeur
	VIAddVersionKey /LANG=${LANG_BULGARIAN} "Comments" "${PRODUCT_COMMENT}"
	VIAddVersionKey /LANG=${LANG_BULGARIAN} "FileDescription" "${PRODUCT_INSTALL_DESCRIPTION} 32  64 bits"
	VIAddVersionKey /LANG=${LANG_BULGARIAN} "FileVersion" "${PRODUCT_VERSION}"
	VIAddVersionKey /LANG=${LANG_BULGARIAN} "InternalName" "${PRODUCT_INSTALL_DESCRIPTION}"
	VIAddVersionKey /LANG=${LANG_BULGARIAN} "LegalCopyright" "Copyright (C) 2006-2011"
	VIAddVersionKey /LANG=${LANG_BULGARIAN} "OriginalFilename" "${INSTALL_FILENAME}"
	VIAddVersionKey /LANG=${LANG_BULGARIAN} "ProductName" "${PRODUCT_NAME}"
	VIProductVersion "${PRODUCT_VERSION}"

;--------------------------------
;Sections d'installation

Section "" ;Vide car commun  toutes les installations
	SetOutPath "$INSTDIR"

	;Cre le programme de suppression
	WriteUninstaller "$INSTDIR\Deinstaller.exe"

	;Ajout de la dsinstallation
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "${PRODUCT_NAME}"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$\"$INSTDIR\Deinstaller.exe$\""
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "InstallLocation" "$INSTDIR"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLUpdateInfo" "${PRODUCT_WEB_SITE}"
	WriteRegDWORD ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "NoModify" 0x1
	WriteRegDWORD ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "NoRepair" 0x1

	;Fichiers communs
	File "..\AUTHORS"
	File "gpl.txt"
	File "..\canaux.ini"
	File "REFERENCES"
	File "..\changelog.html"
	File "..\style.css"
	File "..\MMzinTV.chm"

	;Cre les raccourcis internet
	WriteINIStr "$INSTDIR\${PRODUCT_BASE_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
SectionEnd

Section /o "!${PRODUCT_NAME}  Windows 64 bits" MMzinTV64
${If} ${RunningX64}
	;On a install une version 64 bits de Windows
	StrCpy $INSTALL_X64 "1"

	SetOutPath "$INSTDIR"

	;Les rpertoires sont "All Users"
	SetShellVarContext all

	File "${EXE_SRC_DIR_X64}${EXE_BASENAME_X64}.exe"

	!insertmacro MUI_STARTMENU_WRITE_BEGIN Application

		;Nettoyage pralable (raccourcis obsoltes, rinstallations avec moins d'options) :
		Delete "$SMPROGRAMS\$STARTMENU_FOLDER\   *.lnk"
		Delete "$SMPROGRAMS\$STARTMENU_FOLDER\${PRODUCT_NAME}*.lnk"

		;Cre les raccourcis vers Pouchin
		CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER"
		CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\${PRODUCT_NAME}.lnk" "$INSTDIR\${EXE_BASENAME_X64}.exe"
		;CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Historique des versions.lnk" "$INSTDIR\changelog.html"

		;Raccourci internet
		WriteINIStr "$SMPROGRAMS\$STARTMENU_FOLDER\    ${PRODUCT_BASE_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"

	!insertmacro MUI_STARTMENU_WRITE_END
${EndIf}
SectionEnd

Section /o "${PRODUCT_NAME}  Windows 32 bits" MMzinTV32

	SetOutPath "$INSTDIR"

	SetShellVarContext all

	File "${EXE_SRC_DIR_X86}${EXE_BASENAME_X86}.exe"

	;Cre les raccourcis internet
	WriteINIStr "$INSTDIR\${PRODUCT_BASE_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"

	!insertmacro MUI_STARTMENU_WRITE_BEGIN Application

		;Nettoyage pralable (raccourcis obsoltes, rinstallations avec moins d'options) :
		Delete "$SMPROGRAMS\$STARTMENU_FOLDER\   *.lnk"
		Delete "$SMPROGRAMS\$STARTMENU_FOLDER\${PRODUCT_NAME}*.lnk"

		;Cre les raccourcis vers Pouchin
		CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER"
		CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\${PRODUCT_NAME}.lnk" "$INSTDIR\${EXE_BASENAME_X86}.exe"
		;CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Historique des versions.lnk" "$INSTDIR\changelog.html"

		;Raccourcis internet
		WriteINIStr "$SMPROGRAMS\$STARTMENU_FOLDER\    ${PRODUCT_BASE_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"

	!insertmacro MUI_STARTMENU_WRITE_END

SectionEnd

Section /o "  MMzin USB DVB-T" USBDrivers
	SetOutPath "$PLUGINSDIR"
	File /r "..\usb_drivers\*"
	
${If} ${RunningX64}
	ExecWait '"$PLUGINSDIR\DriverInstall64.exe" /nodialog'		
${Else}
	ExecWait '"$PLUGINSDIR\DriverInstall32.exe" /nodialog'
${EndIf}	
SectionEnd

Section ""	; Dfinit l'icne et sauve le type de la prcdente installation (x32 / x64)
			; Utile simplement pour Windows x64, ignor sinon

${If} $INSTALL_X64 == "0"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\${EXE_BASENAME_X86}.exe,0"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Systeme" "x32"
${Else}
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\${EXE_BASENAME_X64}.exe,0"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Systeme" "x64"
${EndIf}

SectionEnd

SectionGroup /e "  " Icones

	Section "" IconesBG
		SetOutPath "$INSTDIR\Icones\Bulgaria"
		;Ajout des icones des chaines allemandes
		File "..\Icones\Bulgaria\*.bmp"
	SectionEnd

;	Section "  " IconesBGLocales
;		SetOutPath "$INSTDIR\Icones\LocalesBG"
;		;Ajout des icones des chaines locales
;		File "..\Icones\LocalesBG\*.bmp"
;	SectionEnd

	Section "" IconesFR
		SetOutPath "$INSTDIR\Icones"
		;Ajout des icones
		File "..\Icones\*.bmp"
	SectionEnd

	Section "  " IconesFRLocales
		SetOutPath "$INSTDIR\Icones\Locales"
		;Ajout des icones des chaines locales
		File "..\Icones\Locales\*.bmp"
	SectionEnd

	Section /o "" IconesAllemandes
		SetOutPath "$INSTDIR\Icones\Allemandes"
		;Ajout des icones des chaines allemandes
		File "..\Icones\Allemandes\*.bmp"
	SectionEnd

	Section /o "" IconesBelges
		SetOutPath "$INSTDIR\Icones\Belges"
		;Ajout des icones des chaines belges
		File "..\Icones\Belges\*.bmp"
	SectionEnd

	Section /o "" IconesSuisses
		SetOutPath "$INSTDIR\Icones\Suisses"
		;Ajout des icones des chaines suisses
		File "..\Icones\Suisses\*.bmp"
	SectionEnd

	Section /o "DOM-TOM   " IconesDomTom
		SetOutPath "$INSTDIR\Icones\DOM-TOM"
		;Ajout des icones des chaines des Dom-Tom franais
		File "..\Icones\Suisses\*.bmp"
	SectionEnd
	
SectionGroupEnd

Section "  " IconeBureau
	${If} $INSTALL_X64 == "0"
		CreateShortCut "$DESKTOP\${PRODUCT_NAME}.lnk" "$INSTDIR\${EXE_BASENAME_X86}.exe"
	${Else}
		CreateShortCut "$DESKTOP\${PRODUCT_NAME}.lnk" "$INSTDIR\${EXE_BASENAME_X64}.exe"
	${EndIf}
SectionEnd

Section /o "   " MultiTuners
	!insertmacro MUI_STARTMENU_WRITE_BEGIN Application

	${If} $INSTALL_X64 == "0"
		CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\${PRODUCT_NAME} Tuner 2.lnk" "$INSTDIR\${EXE_BASENAME_X86}.exe" "--prefix t2_"
		CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\${PRODUCT_NAME} Tuner 3.lnk" "$INSTDIR\${EXE_BASENAME_X86}.exe" "--prefix t3_"
	${Else}
		CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\${PRODUCT_NAME} Tuner 2.lnk" "$INSTDIR\${EXE_BASENAME_X64}.exe" "--prefix t2_"
		CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\${PRODUCT_NAME} Tuner 3.lnk" "$INSTDIR\${EXE_BASENAME_X64}.exe" "--prefix t3_"
	${EndIf}

	!insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section /o "  " EffaceConfig
	;On supprime la configuration dans "Application Data", et aussi dans "Program Files", car
	;certaines anciennes versions plaaient leurs fichiers l.
	SetShellVarContext current
	Delete "$INSTDIR\config.ini"
	Delete "$INSTDIR\chaines.xml"
	Delete "$APPDATA\${PRODUCT_BASE_NAME}\*config.ini"
	Delete "$APPDATA\${PRODUCT_BASE_NAME}\*chaines.xml"
SectionEnd

Function .onInit

	;Recherche si Pouchin TV Mod est lanc
	FindWindow $0 "${PRODUCT_BASE_NAME}"

${If} $0 != "0"
	MessageBox MB_YESNO "$\"${PRODUCT_NAME}$\" .      ,    .$\n$\r     ?" /SD IDYES IDNO quitte

	;Envoie le message d'arrt
	SendMessage $0 ${WM_CLOSE} 0 0 $0 /TIMEOUT=10000

	;Recherche une seconde fois, pour voir si il est quitt
	FindWindow $0 "${PRODUCT_BASE_NAME}"
	StrCmp $0 "0" suite

quitte:
	MessageBox MB_ICONSTOP "    ,     $\"${PRODUCT_NAME}$\"."
	Abort

suite:

${EndIf}

	;Initialise
	StrCpy $INSTALL_X64 "0"

${If} ${RunningX64}
	;On demande un accs en 64 bits  la base de registres
	SetRegView 64

	;Rcupre la dernire version installe (x32 / x64)
	ReadRegStr $0 ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "System"
	IntOp $0 ${SF_SELECTED} | ${SF_BOLD}
	IntOp $0 $0 | ${SF_RO}

	${If} $0 == "x32"
		;Dernire installation en 32 bits
		SectionSetFlags ${MMzinTV32} $0
		StrCpy $1 ${MMzinTV32}
	${Else}
		${If} $0 == "x64"
		;Dernire installation en 64 bits
			SectionSetFlags ${MMzinTV64} $0
			StrCpy $1 ${MMzinTV64}
		${Else}
			;Pas d'autres installations: slection du 64 bits
			SectionSetFlags ${MMzinTV64} ${SF_SELECTED}
			StrCpy $1 ${MMzinTV64}
		${EndIf}
	${EndIf}

${Else}
	;Supprime la section 64 bits pour les systmes 32 bits
	SectionSetText ${MMzinTV64} ""
	SectionSetSize ${MMzinTV64} 0

	;Met en gras, et en lecture seule la section 32 bits
	IntOp $0 ${SF_SELECTED} | ${SF_BOLD}
	IntOp $0 $0 | ${SF_RO}
	SectionSetFlags ${MMzinTV32} $0

	;Rajoute "requis"  la fin
	SectionGetText ${MMzinTV32} $0
	StrCpy $0 "$0 ()"
	SectionSetText ${MMzinTV32} $0

	;Slectionne par dfaut l'installation 64 bits
	StrCpy $1 ${MMzinTV32}
${EndIf}
	StrCpy $DRIVERS_CHECK 0
FunctionEnd

Function .onSelChange

	!insertmacro StartRadioButtons $1
		!insertmacro RadioButton ${MMzinTV64}
		!insertmacro RadioButton ${MMzinTV32}
	!insertmacro EndRadioButtons

${If} ${IsWin7}
	${If} ${SectionIsSelected} ${USBDrivers}
		${If} $DRIVERS_CHECK = 0
			${If} ${Cmd} `MessageBox MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2 "      !    ?" IDYES`
				StrCpy $DRIVERS_CHECK 1
			${Else}	
				!insertmacro UnselectSection ${USBDrivers}
			${EndIf}	
		${EndIf}	
	${Else}	
		StrCpy $DRIVERS_CHECK 0
	${EndIf}	
${EndIf}
	
FunctionEnd

Function ChangeRep

	;Utilisation du rpertoire de la prcdente install
	StrCmp $INSTDIR "" 0 suite
${If} ${RunningX64}
	;On est en 64bits. On vrifie si l'install en 64 bits est slectionne
	StrCmp $1 ${MMzinTV64} x64
${EndIf}

	;Systme 32bits, ou install en 32 bits slectionne
	StrCpy $INSTDIR "$PROGRAMFILES\${PRODUCT_NAME}\"
	goto suite

x64:
	StrCpy $INSTDIR "$PROGRAMFILES64\${PRODUCT_NAME}\"

suite:

FunctionEnd

;--------------------------------
; Section Suppression

; TODO : Faire en sorte que ne soient retirs que les fichiers qui ont effectivement t installs.
; Voir exemple de comment faire ici :
; http://nsis.sourceforge.net/Uninstall_only_installed_files
;
; Lire aussi le "warning" dans la documentation "RMDir" de NSIS, expliquant pourquoi il est
; peu souhaitable d'excuter une commande "RMDir /r" sur le rpertoire d'installation de l'application.

Section "uninstall"
	SetShellVarContext all

	;Recherche si Pouchin TV Mod est lanc
	FindWindow $0 "${PRODUCT_BASE_NAME}"

${If} $0 != "0"
	;Envoie le message d'arrt
	SendMessage $0 ${WM_CLOSE} 0 0 $0 /TIMEOUT=10000

	;Recherche pour voir si il est quitt
	FindWindow $0 "${PRODUCT_BASE_NAME}"
	StrCmp $0 "0" suite

	MessageBox MB_ICONSTOP "    ,     $\"${PRODUCT_NAME}$\"."
	Abort

${EndIf}
suite:

	;Menu Dmarrer
	!insertmacro MUI_STARTMENU_GETFOLDER Application $STARTMENU_FOLDER
	RMDir /r "$SMPROGRAMS\$STARTMENU_FOLDER"

	; This should fix deinstallation on 64bit
	${If} ${RunningX64}	
	   SetRegView 64
	${EndIf}
	
	DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"

	RMDir /r "$INSTDIR"

	; Raccourci sur le bureau
	Delete "$DESKTOP\${PRODUCT_NAME}"
	
	MessageBox MB_YESNO "$\"${PRODUCT_NAME}$\" .     ,    .$\n$\r     ?" /SD IDYES IDNO quitte

	;"Application Data" de l'utilisateur courant
	SetShellVarContext current
	RMDir /r "$APPDATA\${PRODUCT_BASE_NAME}"

quitte:

SectionEnd

