/*
 * $Id$
 * Copyright (C) 2011 gingko - http://gingko.homeip.net/
 *
 * This file is part of Pouchin TV Mod, a free DVB-T viewer.
 * See http://www.pouchintv.fr/ for updates.
 *
 * Pouchin TV Mod is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Pouchin TV Mod is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#pragma once

#define LZMA_HELP 1

#include <windows.h>
#include "dlgutils.h"

// ====================================================================================

#define SC_0 0	//!< Identifiant pour le template de surclassement

/// Bote de dialogue "Aide"
class CHelpDialogBase : public CModelessDialogPatBase<LPCDLGTEMPLATE>, public WinSubClass<SC_0>
{
	template <int MS, int CS, int TS, int FS>
		struct DLGTEMPLATEEX
	{
		WORD	dlgVer;				// 0
		WORD	signature;			// 2
		DWORD	helpID;				// 4
		DWORD	exStyle;			// 8
		DWORD	style;				// 12
		WORD	cDlgItems;			// 16
		short	x;					// 18
		short	y;					// 20
		short	cx;					// 22
		short	cy;					// 24
		WCHAR	menu[MS+1];			// 26
		WCHAR	windowClass[CS+1];
		WCHAR	title[TS+1];
		WORD	pointsize;			// +2
		WORD	weight;				// +2
		BYTE	italic;				// +1
		BYTE	charset;			// +2
		WCHAR	typeface[FS+1+((MS+CS+TS+FS)&1)];
	};

	template <int CS, int TS, int XS>
		struct DLGITEMTEMPLATEEX
	{
		DWORD	helpID;
		DWORD	exStyle;
		DWORD	style;
		short	x;
		short	y;
		short	cx;
		short	cy;
		DWORD	id;
		WCHAR	windowClass[CS+1];
		WCHAR	title[TS+1];
		WORD	extraCount[XS+1+(((CS+TS+XS)&1)^1)];
	};

	struct HelpTEMPLATE {
		DLGTEMPLATEEX<0, 0, 4, 12>	dlg;
		DLGITEMTEMPLATEEX<11, 0, 0> it1;
		DLGITEMTEMPLATEEX<1, 2, 0>	it2;
	};

	struct ResReader :
	#if LZMA_HELP
		public ByteVector
	#else
		public RawResource
	#endif
	{
		MemRng		sMm;

		DWORD		ESCallback(LPBYTE pbBuff, LONG cb, LONG *pcb);

		static DWORD CALLBACK
					ESCallback(DWORD_PTR dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb) {
						return reinterpret_cast<ResReader *>(dwCookie)->ESCallback(pbBuff, cb, pcb); }

		/// Extraction et dcompression de la ressource d'aide
		bool		Extraction(UINT idRessource);
	};

	enum ItemsId
	{
		eIDC_HELPTEXT	= 1000
	};

	static struct HelpTEMPLATE
						sDlgTmpl;
	tstring				strDlgTitle;
	UINT				idRtfResource;
	HINSTANCE			hRichEdit;
	HWND				hRtfCtl;
	RECT				sSavRect;	//!< Mmorisation du rectangle client dans WM_GETMINMAXINFO et avant WM_SIZE

	virtual LRESULT			SubProc(WinSubClass<SC_0> & sc, UINT uMsg, WPARAM wParam, LPARAM lParam) {
								if (uMsg==EM_SETSEL) return 0;
								return sc.CallWindowProc(uMsg, wParam, lParam); }

	/// Traitement des messages de la bote de dialogue
	virtual INT_PTR			DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

	public:

	/// Constructeur :
	CHelpDialogBase(LPCTSTR pszTitle, UINT idRtfRes) :
		CModelessDialogPatBase(reinterpret_cast<LPCDLGTEMPLATE>(&sDlgTmpl)),
		strDlgTitle(pszTitle),
		idRtfResource(idRtfRes),
		hRichEdit(LoadLibrary(_T("riched20.dll"))),
		hRtfCtl(NULL)
	{
	}

	~CHelpDialogBase() {
		FreeLibrary(hRichEdit); }
};

// ====================================================================================
