/*
 * $Id: msn_notify.h 243 2010-03-17 08:36:42Z gingko $
 * Copyright (C) 2009 gingko - http://gingko.homeip.net/
 *
 * This file is part of Pouchin TV Mod, a free DVB-T viewer.
 * See http://www.pouchintv.fr/ for updates.
 *
 * Pouchin TV Mod is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Pouchin TV Mod is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 *
 * Most files of this project have been changed from the Pouchin TV
 * project (Copyright (C) 2006 Pouchin <pouchinteve@free.fr>),
 * to use with a modified version of this software.
 * See http://pouchinteve.free.fr/ for the original project.
 */

/** \file
 *	\brief Dfinition de la fonctionnalit de communication avec MSN
 *
 *	Ce fichier dfinit les fonctionnalits permettant d'envoyer des messages 
 *	l'application MSN Messenger / Windows Live Messenger.
 **/

#pragma once

/// Gestion des messages envoys  la fentre MSN
class CMSNMsg
{
	bool	msg_set;
	wstring	strLastMsg;	//!< Mmorisation du dernier message envoy

	/**
	 * Envoi d'un message dans la fentre MSN
	 * \param[in]	hMsnWnd	Handle de la fentre MSN
	 * \param[in]	pszMsg	Message  envoyer
	 **/
	void send(HWND hMsnWnd, LPCWSTR pszMsg);
public:
	/// Constructeur
	CMSNMsg() :
		msg_set(false)
	{
	}

	/**
	 * Envoi du nom de la chane et de l'mission dans la fentre MSN,
	 * si l'option correspondante est active
	 *
	 * Infos : http://www.autoitscript.com/forum/index.php?showtopic=43112
	 **/
	void set();

	/**
	 * Effacement du message pralablement envoy dans la fentre MSN,
	 * s'il y en avait un de dfini
	 **/
	void reset();
};
