/*
 * $Id: stdafx.cpp 257 2010-08-03 07:35:33Z gingko $
 * Copyright (C) 2010 gingko - http://gingko.homeip.net/
 *
 * This file is part of Pouchin TV Mod, a free DVB-T viewer.
 * See http://www.pouchintv.fr/ for updates.
 *
 * Pouchin TV Mod is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Pouchin TV Mod is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 *
 * Most files of this project have been changed from the Pouchin TV
 * project (Copyright (C) 2006 Pouchin <pouchinteve@free.fr>),
 * to use with a modified version of this software.
 * See http://pouchinteve.free.fr/ for the original project.
 */

/** \file
 *	\brief Fichier de gnration des en-ttes prcompils.
 *
 *	Bien que n'ayant pas de contenu en lui-mme, ce fichier est ncessaire  la
 *	gnration du systme d'en-ttes prcompils.
 *	Dans le fichier projet, il doit tre le seul  tre configur de manire  tre
 *	compil avec l'option \p /Yc (Crer un en-tte prcompil).
 *	Tous les autres fichiers faisant usage de cette fonctionnalit doivent tre
 *	configurs pour tre compils avec l'option \p /Yu (Utiliser un en-tte prcompil).
 *	En outre, ils doivent avoir la directive  # include "stdafx.h"  prsente au dbut
 *	de toute la liste d'inclusion.
 *
 *	Le fichier d'en-tte prcompils a l'extension \p .pch.
 **/

#include "stdafx.h"


// Les commentaires qui suivent sont destins  la documentation Doxygen de certains
// fichiers C++ qui ne peuvent pas contenir cette documentation par eux-mmes (par exemple
// parce qu'ils sont gnrs automatiquement, ou bien parce qu'ils sont issus d'un projet
// externe).
// Ils n'ont donc rien  voir avec le fichier courant (mais il tait commode de les placer ici).


/** \file version.h
 *	\brief Dfinition du numro de version de Pouchin TV Mod
 *
 *	Fichier gnr automatiquement (par l'utilitaire \p CmdSubst),
 *	avec la dfinition du numro de la version courante de Pouchin TV Mod,
 *	dfini  partir du prfixe contenu dans le fichier version (sans extension)
 *	auquel est accol le numro SVN courant.
 **/

/** \file afxres.h
 *	\brief Inclusion des dfinitions systme lies aux ressources
 *
 *	Ce fichier est inclus par le fichier des ressources, et regroupe les dfinitions
 *	systme ncessaires  la compilation de celles-ci.
 **/

/** \file resource.h
 *	\brief Dfinitions lies aux ressources de l'application
 *
 *	Fichier contenant les dfinitions des numros de chacune des ressources de
 *	l'application.
 *	Ce fichier est inclus  la fois par l'application elle-mme et par son fichier de
 *	ressources.
 **/

/** \file lglcd.h
 *	\brief Fichier d'inclusion pour la bibliothque du clavier Logitech
 *
 *	Ce fichier contient les dfinitions ncessaire pour utiliser la bibliothque
 *	fournie avec les claviers Logitech de type Logitech G15 et drivs avec affichage LCD.
 *
 *	Cet affichage est utilis pour rpliquer les informations dj affiches sur la
 *	fentre, dans l'OSD et dans la zone de notification.
 *	\see http://en.wikipedia.org/wiki/Logitech_G15
 *	\see http://www.logitech.com/index.cfm/keyboards/keyboard/devices/3498
 **/
