/*
 * $Id: stdafx.h 264 2010-11-01 22:49:12Z gingko $
 * Copyright (C) 2010 gingko - http://gingko.homeip.net/
 *
 * This file is part of Pouchin TV Mod, a free DVB-T viewer.
 * See http://www.pouchintv.fr/ for updates.
 *
 * Pouchin TV Mod is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Pouchin TV Mod is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 *
 * Most files of this project have been changed from the Pouchin TV
 * project (Copyright (C) 2006 Pouchin <pouchinteve@free.fr>),
 * to use with a modified version of this software.
 * See http://pouchinteve.free.fr/ for the original project.
 */

/** \file
 *	\brief Fichier d'inclusion gnral pour les en-ttes prcompils.
 *
 *	Ce fichier regroupe toutes les directives d'inclusions de fichiers d'en-ttes \p (.h) qui
 *	doivent tre incluse dans le fichier d'en-tte prcompils.
 *
 *	Il est associ au fichier \p stdafx.cpp, en principe vide, mais servant de dclencheur
 *	 la gnration de ces en-ttes par le fait qu'il est le seul  tre compil (selon le
 *	fichier projet) avec l'option \p /Yc (Crer un en-tte prcompil), alors que les autres
 *	fichiers sont  compiler avec l'option \p /Yu (Utiliser un en-tte prcompil).
 *
 *	Le fichier d'en-tte prcompil a l'extension \p .pch.
 **/

#pragma once

// -----------------------------------------

/// Dfinition Visual C++ permettant de rduire la taille des fichiers
/// d'en-tte Win32 en excluant certaines API peu courantes
#define WIN32_LEAN_AND_MEAN

/// Certains dfinitions multimdia requirent ceci pour exister
#define _INC_MMREG

// -----------------------------------------

/**
 * Dfinition de la version minimale de Windows prise en charge (version avance)
 * \see http://blogs.msdn.com/oldnewthing/archive/2007/04/11/2079137.aspx
 **/
#define NTDDI_VERSION	NTDDI_WINXPSP2		// Windows XP Service Pack 2

/**
 * Dfinition de la version minimale de Windows prise en charge (version hrite)
 * \see http://blogs.msdn.com/oldnewthing/archive/2007/04/11/2079137.aspx
 **/
#define	_WIN32_WINNT	_WIN32_WINNT_WINXP	// Windows XP

/// vite des warnings, y compris dans certains en-ttes Microsoft inclus
#define _CRT_SECURE_NO_WARNINGS
#pragma warning (disable : 4995)			// 'fonction' : le nom a t marqu comme #pragma deprecated

// -----------------------------------------

#ifdef _DEBUG
	#define _CRTDBG_MAP_ALLOC
	// Pour dtection des fuites mmoire
	#include <stdlib.h>
	#include <crtdbg.h>
#endif

#include <windows.h>
#include "streams.h"	// BaseClasses
#include <tchar.h>
#include <commctrl.h>
#include <shlobj.h>

#include <mpeg2data.h>
#include <tuner.h>

#include <wininet.h>

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <initguid.h>
#include <mstask.h>

#include <stdio.h>
#include <math.h>

using namespace std;

// Inclusion des macros d'options de compilation
#include "config.h"

#include "dshow_inc.h" 			// Inclusion des lments DirectShow
#include "atlbase_ptvm.h"		// En-ttes ATL ou substitution
#include "shared_ptr_ptvm.h"	// Template "shared_ptr" ou substitution

// En-ttes Pouchin TV Mod Frquemment requis
#include "resource.h"

#include "utils.h"
#include "console_select.h"
#include "rctutils.h"
#include "xmlutils.h"
#include "errors_ui.h"
#include "ini.h"
#include "main.h"

#include "mpeg2defs.h"
#include "mediadefs.h"
#include "filters.h"
#include "graph.h"
#include "utils.h"
