@echo off
rem
rem $Id: fetch_svn_version.bat 293 2011-05-20 21:12:14Z gingko $
rem Copyright (C) 2011 gingko - http://gingko.homeip.net/
rem
rem This file is part of Pouchin TV Mod, a free DVB-T viewer.
rem See http://www.pouchintv.fr/ for updates.
rem
rem Pouchin TV Mod is free software; you can redistribute it and/or modify
rem it under the terms of the GNU General Public License as published by
rem the Free Software Foundation; either version 2 of the License, or
rem (at your option) any later version.
rem
rem Pouchin TV Mod is distributed in the hope that it will be useful,
rem but WITHOUT ANY WARRANTY; without even the implied warranty of
rem MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
rem GNU General Public License for more details.
rem
rem You should have received a copy of the GNU General Public License
rem along with this program; if not, write to the Free Software
rem Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
rem

rem fetch_svn_version - gnrer les fichiers d'inclusion de version dans diffrents formats
rem
rem Syntaxe : fetch_svn_version.bat FTypes
rem
rem          FTypes  [in] - liste des formats de fichiers dsirs
rem
rem Les valeurs de base de numros de versions doivent avoir pralablement t dfinis
rem dans les variables d'environnement suivantes : VMAJ,VMIN,VFIX,VSFX

rem Prparation du processeur de commande
setlocal ENABLEEXTENSIONS
setlocal ENABLEDELAYEDEXPANSION

set TMPSUFFIX=_$temp_%RANDOM%$

echo ####

rem Test si SubWcRev.exe est disponible
call:searchinpath SWC SubWcRev.exe

rem Test si CmdSubst.exe est disponible
PATH %~p0..\tools;%PATH%
call:searchinpath CSB CmdSubst.exe
if "%CSB%"=="" (
	echo ############# L'utilitaire requis CmdSubst.exe n'est pas disponible
	exit 1
)

rem Valeur par dfaut :
set VREV=8888
set SVNAPP=[aucune application disponible]

if not "%SWC%"=="" (
	rem Dtection de version avec SubWcRev.exe
	echo set VREV=$WCREV$> svnrev%TMPSUFFIX%.tmpl
	echo set SMOD=$WCMODS?"+":""$>> svnrev%TMPSUFFIX%.tmpl
	SubWcRev . svnrev%TMPSUFFIX%.tmpl svnrev%TMPSUFFIX%.bat >NUL
	if errorlevel 6 (
		rem On n'est pas dans un rpertoire versionn. Effectuer un remplacement gnrique.
		set VREV=9999
	) else (
		call svnrev%TMPSUFFIX%.bat
		del svnrev%TMPSUFFIX%.bat
	)
	del svnrev%TMPSUFFIX%.tmpl
	set SVNAPP=%SWC%
) else (
	rem Test si svnversion.exe est disponible
	call:searchinpath SVV svnversion.exe
)

if not "%SVV%"=="" (
	rem Dtection de version avec svnversion.exe
	svnversion | "%CSB%" -r export[ed]+ 9999 M + -r "([0-9]+)[0-9:]*(\+?)" "SET VREV=$1\nSET SMOD=\"$2\"\n"> svnrev%TMPSUFFIX%.bat
	call svnrev%TMPSUFFIX%.bat
	del svnrev%TMPSUFFIX%.bat
	rem type svnrev%TMPSUFFIX%.bat
	set SVNAPP=%SVV%
)

if not "%VREV%"=="8888" goto n8888
	echo #### La gnration automatique du numro de rvision requiert la prsence de l'un des
	echo ####   utilitaires  SubWcRev  (partie de  TortoiseSVN ) ou bien de  svnversion .
	echo #### Le numro de rvision ne peut pas tre gnr correctement.
	echo #### Veuillez tlcharger (et installer)  TortoiseSVN  (http://tortoisesvn.net/) ou
	echo ####   bien un package binaire de  Subversion  (voir http://subversion.apache.org/).
	echo #### La valeur  8888  sera utilise en tant que numro de rvision.
	echo ####
	set SMOD="+"
:n8888
if not "%VREV%"=="9999" goto n9999
	echo #### Le rpertoire courant n'est pas gr par Subversion.
	echo ####   Aucun numro de rvision ne peut en consquence tre obtenu.
	echo #### La valeur  9999  sera utilise en tant que numro de rvision.
	echo ####
	set SMOD="+"
:n9999

set NMOD=0
if %SMOD%=="+" set NMOD=1

rem Examiner tous les fichiers modle pour chaque type de fichier  inclure
for %%a in (%~1) do call:onefile %%a

rem Affichage de la version compile
call version.bat
echo #### Version compile: %PRODUCT_VERSION%
echo ####

rem Effacement des variables d'environnement temporairement utilises
set VREV=
set SMOD=
set PFX=
set SWC=
set SVV=
set SVNAPP=
goto:eof

rem ============================================================================================
rem Sous-programme : traitement d'un fichier modle
rem ============================================================================================

:onefile
rem Nettoyage prliminaire par prcaution :
if exist "%~p0version_%1.tmpl" if exist version%TMPSUFFIX%.%1 del version%TMPSUFFIX%.%1

if "%WCREV%"=="9999" (
	rem Si un fichier de version existe dj et qu'aucun logiciel ne peut en dterminer un nouveau, on garde celui-l.
	if exist version.%1 goto:eof
)
PATH %~p0;%PATH%
call:searchinpath TMPL version_%1.tmpl
type "%TMPL%" | "%CSB%" #VREV# %VREV% #SMOD# %SMOD% #NMOD# %NMOD% #VSFX# %VSFX% #VMAJ# %VMAJ% #VMIN# %VMIN% #VFIX# %VFIX% #TMPL# "%TMPL%" #CSB# "%CSB%" #SVNAPP# "%SVNAPP%"> version%TMPSUFFIX%.%1
if errorlevel 1 exit /b 1

rem Comparaison de "version%TMPSUFFIX%.%1" avec le fichier "version.%1" courant.
rem S'ils sont diffrents, "version%TMPSUFFIX%.%1" devient le nouveau "version.%1"
rem (ainsi la date de modification "version.%1" ne change que si c'est appropri)
rem
echo n | comp version%TMPSUFFIX%.%1 version.%1 2>NUL >NUL
rem Code retour : 0 = fichiers identiques, 1 = fichiers diffrents, 2 = fichier inexistant
if errorlevel 1 (
	if exist version%TMPSUFFIX%.%1 (
		if exist version.%1 del version.%1
		ren version%TMPSUFFIX%.%1 version.%1
		echo #### Un nouveau fichier de version "version.%1" a t gnr
	)
) else (
	del version%TMPSUFFIX%.%1
)
goto:eof

rem ============================================================================================
rem Sous-programme : Rechercher si une application existe dans le 'PATH'
rem ============================================================================================

:searchinpath
set %1=%~$PATH:2
rem Forcer la casse de la lettre de lecteur : certains OS la gnrent en minuscules, d'autres en
rem majuscules, et c'est empoisonnant quand on veut comparer deux copies de travail entre elles.
set %~1=!%1:a:=A:!
set %~1=!%1:b:=B:!
set %~1=!%1:c:=C:!
set %~1=!%1:d:=D:!
set %~1=!%1:e:=E:!
set %~1=!%1:f:=F:!
set %~1=!%1:g:=G:!
set %~1=!%1:h:=H:!
set %~1=!%1:i:=I:!
set %~1=!%1:j:=J:!
set %~1=!%1:k:=K:!
set %~1=!%1:l:=L:!
set %~1=!%1:m:=M:!
set %~1=!%1:n:=N:!
set %~1=!%1:o:=O:!
set %~1=!%1:p:=P:!
set %~1=!%1:q:=Q:!
set %~1=!%1:r:=R:!
set %~1=!%1:s:=S:!
set %~1=!%1:t:=T:!
set %~1=!%1:u:=U:!
set %~1=!%1:v:=V:!
set %~1=!%1:w:=W:!
set %~1=!%1:x:=X:!
set %~1=!%1:y:=Y:!
set %~1=!%1:z:=Z:!
